package com.bmw.cascade.pruefstand.ediabas;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.*;

public class EdiabasJTool extends JFrame {
        public static ResourceBundle bundle;

        static {
                bundle = ResourceBundle.getBundle( "com.bmw.cascade.pruefstand.ediabas.EdiabasJTool" );
        }

        public static void main( String[] args ) {
                EdiabasJTool jtool = new EdiabasJTool( "Ediabas JTool" );
                jtool.setVisible( true );
        }

        public EdiabasJTool( String title ) {
                super( title );
                setDefaultCloseOperation( DISPOSE_ON_CLOSE );
                getContentPane().add( getInteractionPanel(), BorderLayout.NORTH );
                getContentPane().add( getResultPane(), BorderLayout.CENTER );
                getContentPane().add( getInteractionPanel2(), BorderLayout.SOUTH );
                pack();
        }

        public void dispose() {
                super.dispose();
                System.exit( 0 );
        }

        private ActionListener actionListener;
        private ActionListener getActionListener() {
                if( actionListener == null ) {
                        actionListener = new ActionHandler();
                }
                return actionListener;
        }

        private JPanel interactionPanel;
        private JPanel getInteractionPanel() {
                if( interactionPanel == null ) {
                        interactionPanel = new JPanel( new GridLayout( 1, 1 ) );
                        interactionPanel.add( getInputPanel() );
                }
                return interactionPanel;
        }

        private JPanel interactionPanel2;
        private JPanel getInteractionPanel2() {
                if( interactionPanel2 == null ) {
                        interactionPanel2 = new JPanel( new GridLayout( 1, 1 ) );
                        interactionPanel2.add( getButtonPanel() );
                }
                return interactionPanel2;
        }

        private JPanel buttonPanel;
        private JPanel getButtonPanel() {
                if( buttonPanel == null ) {
                        buttonPanel = new JPanel( new FlowLayout( FlowLayout.RIGHT ) );
                        buttonPanel.add( getStartButton() );
                        //buttonPanel.add( getStartButtonData() );
                        buttonPanel.add( getExitButton() );
                }
                return buttonPanel;
        }

        private JButton exitButton;
        private JButton getExitButton() {
                if( exitButton == null ) {
                        exitButton = new JButton( bundle.getString( "EdiabasJTool.button.exit" ) );
                        exitButton.addActionListener( getActionListener() );
                }
                return exitButton;
        }

        private JButton startButton;
        private JButton getStartButton() {
                if( startButton == null ) {
                        startButton = new JButton( bundle.getString( "EdiabasJTool.button.start" ) );
                        startButton.addActionListener( getActionListener() );
                }
                return startButton;
        }

        private JButton startButtonData;
        private JButton getStartButtonData() {
                if( startButtonData == null ) {
                        startButtonData = new JButton( bundle.getString( "EdiabasJTool.button.startData" ) );
                        startButtonData.addActionListener( getActionListener() );
                }
                return startButtonData;
        }

        private JPanel inputPanel;
        private JPanel getInputPanel() {
                if( inputPanel == null ) {
                        inputPanel = new JPanel( new GridLayout( 2, 2 ) );
                        inputPanel.add( getSgbdInputField() );
                        inputPanel.add( getJobInputField() );
                        inputPanel.add( getParameterInputField() );
                        inputPanel.add( getResultsInputField() );
                        inputPanel.setBorder( new TitledBorder( bundle.getString( "EdiabasJTool.label.ediabasJobParams" ) ) );
                }
                return inputPanel;
        }

        private JTextField sgbdInputField;
        private JTextField getSgbdInputField() {
                if( sgbdInputField == null ) {
                        sgbdInputField = new JTextField( 20 );
                        sgbdInputField.setBorder( new TitledBorder( bundle.getString( "EdiabasJTool.label.sgbd" ) ) );
                }
                return sgbdInputField;
        }

        private JTextField jobInputField;
        private JTextField getJobInputField() {
                if( jobInputField == null ) {
                        jobInputField = new JTextField( 20 );
                        jobInputField.setBorder( new TitledBorder( bundle.getString( "EdiabasJTool.label.job" ) ) );
                }
                return jobInputField;
        }

        private JTextField parameterInputField;
        private JTextField getParameterInputField() {
                if( parameterInputField == null ) {
                        parameterInputField = new JTextField( 20 );
                        parameterInputField.setBorder( new TitledBorder( bundle.getString( "EdiabasJTool.label.parameter" ) ) );
                }
                return parameterInputField;
        }

        private JTextField resultsInputField;
        private JTextField getResultsInputField() {
                if( resultsInputField == null ) {
                        resultsInputField = new JTextField( 20 );
                        resultsInputField.setBorder( new TitledBorder( bundle.getString( "EdiabasJTool.label.results" ) ) );
                }
                return resultsInputField;
        }

        private JScrollPane resultPane;
        private JScrollPane getResultPane() {
                if( resultPane == null ) {
                        resultPane = new JScrollPane( getResultArea() );
                        resultPane.setBorder( new TitledBorder( bundle.getString( "EdiabasJTool.label.resultArea" ) ) );
                }
                return resultPane;
        }

        private JTextArea resultArea;
        private JTextArea getResultArea() {
                if( resultArea == null ) {
                        resultArea = new JTextArea( 25, 80 );
                        resultArea.setEditable( false );
                }
                return resultArea;
        }

        private class ActionHandler implements ActionListener {
                public void actionPerformed( ActionEvent e ) {
                        Object src = e.getSource();
                        if( src == getExitButton() ) {
                                dispose();
                        } else if( src == getStartButton() ) {
                                try {
                                        Ediabas.apiInit();
                                        Ediabas.apiJob( getSgbdInputField().getText().trim(), getJobInputField().getText().trim(), getParameterInputField().getText().trim(), getResultsInputField().getText().trim() );
                                        getResultArea().setText( Ediabas.getResult().toString() );
                                        Ediabas.apiEnd();
                                } catch( ApiCallFailedException exc ) {
                                        getResultArea().setText( Ediabas.apiErrorCode()+": " + Ediabas.apiErrorText() );
                                        JOptionPane.showMessageDialog( EdiabasJTool.this, Ediabas.apiErrorCode()+": " + Ediabas.apiErrorText(), bundle.getString( "EdiabasJTool.dialog.ApiCallFailedException" ), JOptionPane.ERROR_MESSAGE );
                                }
                        } else if( src == getStartButtonData() ) {
                                try {
                                  short[] buffer = fillBuffer( getParameterInputField().getText().trim() ); 
                                  try {
                                    //System.out.print("Data:");
                                    //for(int i=0;i<buffer.length;i++) System.out.print(" "+buffer[i]);
                                    //System.out.println("");
                                    Ediabas.apiInit();
                                    Ediabas.apiJobData( getSgbdInputField().getText().trim(), getJobInputField().getText().trim(), buffer, getResultsInputField().getText().trim() );
                                    getResultArea().setText( Ediabas.getResult().toString() );
                                    Ediabas.apiEnd();
                                  } catch( ApiCallFailedException exc ) {
                                    getResultArea().setText( Ediabas.apiErrorCode()+": " + Ediabas.apiErrorText() );
                                    JOptionPane.showMessageDialog( EdiabasJTool.this, Ediabas.apiErrorCode()+": " + Ediabas.apiErrorText(), bundle.getString( "EdiabasJTool.dialog.ApiCallFailedException" ), JOptionPane.ERROR_MESSAGE );
                                  }
                                } catch (NumberFormatException exc) {
                                  getResultArea().setText( "Invalid Parameters" );
                                  JOptionPane.showMessageDialog( EdiabasJTool.this, "Invalid Parameters", bundle.getString( "EdiabasJTool.dialog.ApiCallFailedException" ), JOptionPane.ERROR_MESSAGE );
                                }
                        }

                }
        }
        

        private short[] fillBuffer (String text) throws NumberFormatException {
                String teil;
                Integer help;
                short[] data = null;
                int pos = 0;
                int counter = 0;
                int adr = 0;
                
                if (text.compareTo("") == 0) throw new NumberFormatException();
                
                counter = 0;
                teil = text;
                for(int i = 0; i <= 1; i++) {
                  if (i != 0) {
                    adr = 0;
                    data = new short[counter];
                    text = teil; 
                  }
                  while (text != "") {
                    pos = text.indexOf(' ');
                    if (pos < 0) {
                      if (i != 0) teil = text;
                      text = "";
                    } else {
                      if (i != 0) teil = text.substring(0,pos);
                      text = (text.substring(pos)).trim();
                    }
                    if (i == 0) {
                      counter++;
                    } else {
                      help = new Integer(Integer.parseInt(teil,16));
                      if ((help.intValue() < 0) || (help.intValue() > 255)) throw new NumberFormatException();
                      data[adr] = help.shortValue();
                      adr++;
                    }
                  }
                }
                return data;
        }       
}
